var Wave1 : array[0..30000] of Byte;
    Data  : array[0..30000] of Byte;

{ IN: DS:DX = buffer to be packed }
{     CX    = buffer length       }
{     BX    = file handle to write}
Procedure rlPack; assembler;
asm             push    bx
                mov     si,dx
                mov     ax,seg Wave1
                mov     es,ax
                mov     di,offset Wave1 + 2

@@packData:     mov     bx,si
                mov     ah,[si]
                xor     dx,dx
@@countNEQ:     mov     al,[si+1]
                cmp     al,ah
                je      @@foundEQ
                mov     ah,al
                inc     dx
                inc     si
                dec     cx
                jne     @@countNEQ
@@foundEQ:      test    dx,dx
                jz      @@noNEQdata
                mov     si,bx
                mov     bx,cx
                mov     cx,dx
                dec     dx
                cmp     dx,127
                jae     @@NEQmt127
                mov     al,dl
                or      al,10000000b
                stosb
                jmp     @@copyData
@@NEQmt127:     mov     al,0FFh
                stosb
                mov     ax,dx
                stosw
@@copyData:     shr     cx,1
                rep     movsw
                adc     cl,cl
                rep     movsb
                mov     cx,bx
                test    cx,cx
                jz      @@packDone

@@noNEQdata:    mov     al,[si]
                xor     dx,dx
@@countEQ:      inc     dx
                inc     si
                dec     cx
                jz      @@foundNEQ
                cmp     al,[si]
                je      @@countEQ
@@foundNEQ:     cmp     dx,2
                jb      @@noEQdata
                dec     dx
                dec     dx
                cmp     dx,127
                jae     @@EQmt127
                xchg    al,dl
                stosb
                xchg    al,dl
                stosb
                jmp     @@noEQdata
@@EQmt127:      mov     es:[di+3],al
                mov     al,07Fh
                stosb
                mov     ax,dx
                stosw
                inc     di              {Skip 'BYTE' field}
@@noEQdata:     test    cx,cx
                jnz     @@packData
@@packDone:     sub     di,offset Wave1
                mov     word ptr es:Wave1,di
                pop     bx
                push    ds
                mov     cx,di
                inc     cx
                inc     cx
                mov     dx,offset Wave1
                mov     ax,es
                mov     ds,ax
                mov     ah,40h
                int     21h
                pop     ds
end;

{ IN: DS:DX = destination uffer address}
{     BX    = file handle to read from }
Procedure rlUnpack; assembler;
asm             push    ds
                mov     di,dx
                mov     ax,ds
                mov     es,ax
                mov     ax,seg Wave1
                mov     ds,ax
                mov     dx,offset Wave1
                mov     cx,2
                mov     ah,3Fh
                int     21h
                jc      @@error
                mov     cx,word ptr ds:Wave1
                mov     ah,3Fh
                inc     dx
                inc     dx
                int     21h
                jc      @@error
                mov     si,offset Wave1
                mov     bx,[si]
                inc     si
                inc     si

@@unpackData:   mov     dx,1
                mov     ch,0
                mov     cl,[si]
                inc     si
                test    cl,10000000b
                je      @@RLpacket
                and     cl,01111111b
                cmp     cl,07Fh
                jne     @@noExtLen1
                mov     cx,[si]
                inc     si
                inc     si
                inc     dx
                inc     dx
@@noExtLen1:    inc     cx
                shr     cx,1
                rep     movsw
                adc     cl,cl
                rep     movsb
                sub     bx,dx
                ja      @@unpackData
                jmp     @@unpackDone

@@RLpacket:     cmp     cl,07Fh
                jne     @@noExtLen2
                mov     cx,[si]
                inc     si
                inc     si
                inc     dx
                inc     dx
@@noExtLen2:    inc     cx
                inc     cx
                lodsb
                inc     dx
                mov     ah,al
                shr     cx,1
                rep     stosw
                adc     cl,cl
                rep     stosb
                sub     bx,dx
                ja      @@unpackData
@@unpackDone:
@@error:        pop     ds
end;

var f : file;
    s : word;
    q : string;

begin
 assign(f,'presents.bin');
 reset(f,1);
 s := filesize(f);
 blockread(f,data,s);
 close(f);
 q := 'out.pak'#0;
 asm      mov  ah,3Ch
          mov  cx,20h
          mov  dx,offset q[1]
          int  21h
          mov  bx,ax
          mov  dx,offset data
          mov  cx,s
          call rlPack
          mov  ah,3Eh
          int  21h
 end;
 fillchar(data,sizeof(data),0);
 asm      mov  ax,3D00h
          mov  dx,offset q[1]
          int  21h
          mov  bx,ax
          mov  dx,offset data
          call rlUnpack
          mov  ah,3Eh
          int  21h
 end;
 assign(f,'res.bin');
 rewrite(f,1);
 blockwrite(f,data,s);
 close(f);
end.
